diff --git a/misc/Makefile b/misc/Makefile
index d7bbc85..658d4ba 100644
--- a/misc/Makefile
+++ b/misc/Makefile
@@ -88,6 +88,8 @@ CFLAGS-lsearch.c = $(uses-callbacks)
 CFLAGS-pselect.c = -fexceptions
 CFLAGS-readv.c = -fexceptions -fasynchronous-unwind-tables
 CFLAGS-writev.c = -fexceptions -fasynchronous-unwind-tables
+CFLAGS-preadv.c = -fexceptions -fasynchronous-unwind-tables
+CFLAGS-preadv64.c = -fexceptions -fasynchronous-unwind-tables
 CFLAGS-usleep.c = -fexceptions
 CFLAGS-syslog.c = -fexceptions
 CFLAGS-error.c = -fexceptions
diff --git a/nptl/tst-cancel4.c b/nptl/tst-cancel4.c
index 1478174..30c3850 100644
--- a/nptl/tst-cancel4.c
+++ b/nptl/tst-cancel4.c
@@ -1554,6 +1554,50 @@ tf_pwrite (void *arg)
   exit (1);
 }
 
+static void *
+tf_preadv (void *arg)
+{
+  int fd;
+  int r;
+
+  if (arg == NULL)
+    // XXX If somebody can provide a portable test case in which pwrite()
+    // blocks we can enable this test to run in both rounds.
+    abort ();
+
+  char fname[] = "/tmp/tst-cancel4-fd-XXXXXX";
+  tempfd = fd = mkstemp (fname);
+  if (fd == -1)
+    printf ("%s: mkstemp failed\n", __FUNCTION__);
+  unlink (fname);
+
+  r = pthread_barrier_wait (&b2);
+  if (r != 0 && r != PTHREAD_BARRIER_SERIAL_THREAD)
+    {
+      printf ("%s: barrier_wait failed\n", __FUNCTION__);
+      exit (1);
+    }
+
+  r = pthread_barrier_wait (&b2);
+  if (r != 0 && r != PTHREAD_BARRIER_SERIAL_THREAD)
+    {
+      printf ("%s: barrier_wait failed\n", __FUNCTION__);
+      exit (1);
+    }
+
+  ssize_t s;
+  pthread_cleanup_push (cl, NULL);
+
+  char buf[100];
+  struct iovec iov[1] = { [0] = { .iov_base = buf, .iov_len = sizeof (buf) } };
+  s = preadv (fd, iov, 1, 0);
+
+  pthread_cleanup_pop (0);
+
+  printf ("%s: preadv returns with %zd\n", __FUNCTION__, s);
+
+  exit (1);
+}
 
 static void *
 tf_fsync (void *arg)
@@ -2140,6 +2184,7 @@ static struct
   ADD_TEST (recv, 2, 0),
   ADD_TEST (recvfrom, 2, 0),
   ADD_TEST (recvmsg, 2, 0),
+  ADD_TEST (preadv, 2, 1),
   ADD_TEST (open, 2, 1),
   ADD_TEST (close, 2, 1),
   ADD_TEST (pread, 2, 1),
diff --git a/sysdeps/unix/sysv/linux/generic/wordsize-32/preadv.c b/sysdeps/unix/sysv/linux/generic/wordsize-32/preadv.c
deleted file mode 100644
index ec30d4c..0000000
--- a/sysdeps/unix/sysv/linux/generic/wordsize-32/preadv.c
+++ /dev/null
@@ -1,38 +0,0 @@
-/* Copyright (C) 2011-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Chris Metcalf <cmetcalf@tilera.com>, 2011.
-   Based on work contributed by Ulrich Drepper <drepper@cygnus.com>, 1997.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <assert.h>
-#include <errno.h>
-#include <endian.h>
-#include <unistd.h>
-#include <sys/uio.h>
-
-#include <sysdep-cancel.h>
-#include <sys/syscall.h>
-
-ssize_t
-__libc_preadv (int fd, const struct iovec *vector, int count, off_t offset)
-{
-  assert (sizeof (offset) == 4);
-  return SYSCALL_CANCEL (preadv, fd,
-                         vector, count, __ALIGNMENT_ARG
-                         __LONG_LONG_PAIR (offset >> 31, offset));
-}
-strong_alias (__libc_preadv, __preadv)
-weak_alias (__libc_preadv, preadv)
diff --git a/sysdeps/unix/sysv/linux/generic/wordsize-32/preadv64.c b/sysdeps/unix/sysv/linux/generic/wordsize-32/preadv64.c
deleted file mode 100644
index fc008c6..0000000
--- a/sysdeps/unix/sysv/linux/generic/wordsize-32/preadv64.c
+++ /dev/null
@@ -1,38 +0,0 @@
-/* Copyright (C) 2011-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Contributed by Chris Metcalf <cmetcalf@tilera.com>, 2011.
-   Based on work contributed by Ulrich Drepper <drepper@cygnus.com>, 1997.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library.  If not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <endian.h>
-#include <unistd.h>
-#include <sys/uio.h>
-
-#include <sysdep-cancel.h>
-#include <sys/syscall.h>
-
-ssize_t
-__libc_preadv64 (int fd, const struct iovec *vector, int count, off64_t offset)
-{
-  return SYSCALL_CANCEL (preadv, fd,
-                         vector, count, __ALIGNMENT_ARG
-                         __LONG_LONG_PAIR ((off_t) (offset >> 32),
-                                           (off_t) (offset & 0xffffffff)));
-}
-
-strong_alias (__libc_preadv64, __preadv64)
-weak_alias (__libc_preadv64, preadv64)
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/n64/preadv64.c b/sysdeps/unix/sysv/linux/mips/mips64/n64/preadv64.c
deleted file mode 100644
index fd9320c..0000000
--- a/sysdeps/unix/sysv/linux/mips/mips64/n64/preadv64.c
+++ /dev/null
@@ -1 +0,0 @@
-/* Empty since the preadv syscall is equivalent.  */
diff --git a/sysdeps/unix/sysv/linux/preadv.c b/sysdeps/unix/sysv/linux/preadv.c
index ca8da33..f6958c3 100644
--- a/sysdeps/unix/sysv/linux/preadv.c
+++ b/sysdeps/unix/sysv/linux/preadv.c
@@ -15,67 +15,40 @@
    License along with the GNU C Library; if not, see
    <http://www.gnu.org/licenses/>.  */
 
-#include <errno.h>
-#include <stddef.h>
-#include <sys/param.h>
-#include <stdint.h>
-#if __WORDSIZE == 64
-/* Hide the preadv64 declaration.  */
-# define preadv64 __redirect_preadv64
-#endif
 #include <sys/uio.h>
-
 #include <sysdep-cancel.h>
-#include <sys/syscall.h>
-#include <kernel-features.h>
-
-
-#ifndef PREADV
-# define PREADV preadv
-# define PREADV_REPLACEMENT __atomic_preadv_replacement
-# define PREAD __pread
-# define OFF_T off_t
-#endif
 
-#define LO_HI_LONG(val) \
-  (off_t) val,								\
-  (off_t) ((((uint64_t) (val)) >> (sizeof (long) * 4)) >> (sizeof (long) * 4))
+#if __WORDSIZE != 64 || defined (__ASSUME_OFF_DIFF_OFF64)
 
-#ifndef __ASSUME_PREADV
-static ssize_t PREADV_REPLACEMENT (int, const struct iovec *,
-				   int, OFF_T) internal_function;
-#endif
+# ifdef __ASSUME_PREADV
 
+#  ifndef __NR_preadv
+#   define __NR_preadv __NR_preadv64
+#  endif
 
 ssize_t
-PREADV (int fd, const struct iovec *vector, int count, OFF_T offset)
+preadv (int fd, const struct iovec *vector, int count, off_t offset)
 {
-#ifdef __NR_preadv
-  ssize_t result;
-
-  result = SYSCALL_CANCEL (preadv, fd, vector, count, LO_HI_LONG (offset));
-
-# ifdef __ASSUME_PREADV
-  return result;
-# endif
-#endif
-
-#ifndef __ASSUME_PREADV
-# ifdef __NR_preadv
+  return SYSCALL_CANCEL (preadv, fd, vector, count,
+			 __ALIGNMENT_ARG SYSCALL_LL (offset));
+}
+# else
+static ssize_t __atomic_preadv_replacement (int, const struct iovec *,
+					    int, off_t) internal_function;
+ssize_t
+preadv (int fd, const struct iovec *vector, int count, off_t offset)
+{
+#  ifdef __NR_preadv
+  ssize_t result = SYSCALL_CANCEL (preadv, fd, vector, count,
+				   __ALIGNMENT_ARG SYSCALL_LL (offset));
   if (result >= 0 || errno != ENOSYS)
     return result;
-# endif
-
-  return PREADV_REPLACEMENT (fd, vector, count, offset);
-#endif
+#  endif
+  return __atomic_preadv_replacement (fd, vector, count, offset);
 }
-#if __WORDSIZE == 64
-# undef preadv64
-strong_alias (preadv, preadv64)
-#endif
-
-#ifndef __ASSUME_PREADV
-# undef PREADV
-# define PREADV static internal_function PREADV_REPLACEMENT
-# include <sysdeps/posix/preadv.c>
+#  define PREADV static internal_function __atomic_preadv_replacement
+#  define PREAD __pread
+#  define OFF_T off_t
+#  include <sysdeps/posix/preadv.c>
+# endif /* __ASSUME_PREADV  */
 #endif
diff --git a/sysdeps/unix/sysv/linux/preadv64.c b/sysdeps/unix/sysv/linux/preadv64.c
index 936ff14..18f5550 100644
--- a/sysdeps/unix/sysv/linux/preadv64.c
+++ b/sysdeps/unix/sysv/linux/preadv64.c
@@ -1,6 +1,55 @@
-#define PREADV preadv64
-#define PREADV_REPLACEMENT __atomic_preadv64_replacement
-#define PREAD __libc_pread64
-#define OFF_T off64_t
+/* Copyright (C) 2016 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
 
-#include "preadv.c"
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <http://www.gnu.org/licenses/>.  */
+
+#include <sys/uio.h>
+#include <sysdep-cancel.h>
+
+#ifdef __ASSUME_PREADV
+
+# ifndef __NR_preadv64
+#  define __NR_preadv64 __NR_preadv
+# endif
+
+ssize_t
+preadv64 (int fd, const struct iovec *vector, int count, off64_t offset)
+{
+  return SYSCALL_CANCEL (preadv64, fd, vector, count,
+			 __ALIGNMENT_ARG SYSCALL_LL64 (offset));
+}
+#else
+static ssize_t __atomic_preadv64_replacement (int, const struct iovec *,
+					      int, off64_t) internal_function;
+ssize_t
+preadv64 (int fd, const struct iovec *vector, int count, off64_t offset)
+{
+#ifdef __NR_preadv64
+  ssize_t result = SYSCALL_CANCEL (preadv64, fd, vector, count,
+				   __ALIGNMENT_ARG SYSCALL_LL64 (offset));
+  if (result >= 0 || errno != ENOSYS)
+    return result;
+#endif
+  return __atomic_preadv64_replacement (fd, vector, count, offset);
+}
+# define PREADV static internal_function __atomic_preadv64_replacement
+# define PREAD __pread64
+# define OFF_T off64_t
+# include <sysdeps/posix/preadv.c>
+#endif
+
+#if __WORDSIZE == 64 && !defined (__ASSUME_OFF_DIFF_OFF64)
+strong_alias (preadv64, preadv)
+#endif
diff --git a/sysdeps/unix/sysv/linux/wordsize-64/preadv.c b/sysdeps/unix/sysv/linux/wordsize-64/preadv.c
deleted file mode 100644
index e2924ac..0000000
--- a/sysdeps/unix/sysv/linux/wordsize-64/preadv.c
+++ /dev/null
@@ -1,64 +0,0 @@
-/* 64-bit preadv.
-   Copyright (C) 2012-2016 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <stddef.h>
-#include <sys/param.h>
-/* Hide the preadv64 declaration.  */
-#define preadv64 __redirect_preadv64
-#include <sys/uio.h>
-
-#include <sysdep-cancel.h>
-#include <sys/syscall.h>
-#include <kernel-features.h>
-
-#ifndef __ASSUME_PREADV
-static ssize_t __atomic_preadv_replacement (int, const struct iovec *,
-					    int, off_t) internal_function;
-#endif
-
-ssize_t
-preadv (int fd, const struct iovec *vector, int count, off_t offset)
-{
-#ifdef __NR_preadv
-  ssize_t result;
-
-  result = SYSCALL_CANCEL (preadv, fd, vector, count, offset);
-# ifdef __ASSUME_PREADV
-  return result;
-# endif
-#endif
-
-#ifndef __ASSUME_PREADV
-# ifdef __NR_preadv
-  if (result >= 0 || errno != ENOSYS)
-    return result;
-# endif
-
-  return __atomic_preadv_replacement (fd, vector, count, offset);
-#endif
-}
-#undef preadv64
-strong_alias (preadv, preadv64)
-
-#ifndef __ASSUME_PREADV
-# define PREADV static internal_function __atomic_preadv_replacement
-# define PREAD __pread
-# define OFF_T off_t
-# include <sysdeps/posix/preadv.c>
-#endif
diff --git a/sysdeps/unix/sysv/linux/wordsize-64/preadv64.c b/sysdeps/unix/sysv/linux/wordsize-64/preadv64.c
deleted file mode 100644
index fd9320c..0000000
--- a/sysdeps/unix/sysv/linux/wordsize-64/preadv64.c
+++ /dev/null
@@ -1 +0,0 @@
-/* Empty since the preadv syscall is equivalent.  */
diff --git a/sysdeps/unix/sysv/linux/x86_64/x32/syscalls.list b/sysdeps/unix/sysv/linux/x86_64/x32/syscalls.list
index c98ac74..58cd7fc 100644
--- a/sysdeps/unix/sysv/linux/x86_64/x32/syscalls.list
+++ b/sysdeps/unix/sysv/linux/x86_64/x32/syscalls.list
@@ -4,6 +4,5 @@ fallocate	-	fallocate	Ci:iiii	fallocate	fallocate64
 gettimeofday	-	gettimeofday:__vdso_gettimeofday@LINUX_2.6	i:pP	__gettimeofday	gettimeofday
 personality	EXTRA	personality	Ei:i	__personality	personality
 posix_fadvise	-	fadvise64	Vi:iiii	posix_fadvise	posix_fadvise64
-preadv		-	preadv		Ci:ipii	preadv		preadv64
 pwritev		-	pwritev		Ci:ipii	pwritev		pwritev64
 time		-	time:__vdso_time@LINUX_2.6			Ei:P	time